Bug 2271998 (CVE-2024-31081)

Summary: CVE-2024-31081 xorg-x11-server: Heap buffer overread/data leakage in ProcXIPassiveGrabDevice
Product: [Other] Security Response Reporter: TEJ RATHI <trathi>
Component: vulnerabilityAssignee: Product Security <prodsec-ir-bot>
Status: NEW --- QA Contact:
Severity: high Docs Contact:
Priority: high    
Version: unspecifiedCC: jgrulich, saroy, security-response-team, tpopela
Target Milestone: ---Keywords: Security
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard:
Fixed In Version: xorg-server 21.1.12, xwayland 23.2.5 Doc Type: If docs needed, set a value
Doc Text:
A heap-based buffer over-read vulnerability was found in the X.org server's ProcXIPassiveGrabDevice() function. This issue occurs when byte-swapped length values are used in replies, potentially leading to memory leakage and segmentation faults, particularly when triggered by a client with a different endianness. This vulnerability could be exploited by an attacker to cause the X server to read heap memory values and then transmit them back to the client until encountering an unmapped page, resulting in a crash. Despite the attacker's inability to control the specific memory copied into the replies, the small length values typically stored in a 32-bit integer can result in significant attempted out-of-bounds reads.
Story Points: ---
Clone Of: Environment:
Last Closed: Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: --- Target Upstream Version:
Embargoed:
Bug Depends On: 2273328, 2273326, 2273327    
Bug Blocks: 2272001    

Description TEJ RATHI 2024-03-28 04:27:01 UTC
The ProcXIPassiveGrabDevice() function uses the byte-swapped length of the return data for the amount of data to return to the client, if the client
has a different endianness than the X server.

Introduced in: xorg-server-1.7.0 (2009)

Comment 3 Sandipan Roy 2024-04-04 08:18:12 UTC
Created tigervnc tracking bugs for this issue:

Affects: fedora-all [bug 2273328]


Created xorg-x11-server tracking bugs for this issue:

Affects: fedora-all [bug 2273326]


Created xorg-x11-server-Xwayland tracking bugs for this issue:

Affects: fedora-all [bug 2273327]

Comment 5 errata-xmlrpc 2024-04-11 16:50:20 UTC
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 7

Via RHSA-2024:1785 https://access.redhat.com/errata/RHSA-2024:1785

Comment 9 errata-xmlrpc 2024-04-24 15:28:55 UTC
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 8

Via RHSA-2024:2037 https://access.redhat.com/errata/RHSA-2024:2037

Comment 10 errata-xmlrpc 2024-04-24 15:32:03 UTC
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 9.0 Extended Update Support

Via RHSA-2024:2036 https://access.redhat.com/errata/RHSA-2024:2036

Comment 11 errata-xmlrpc 2024-04-24 15:33:40 UTC
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 8.2 Advanced Update Support
  Red Hat Enterprise Linux 8.2 Telecommunications Update Service
  Red Hat Enterprise Linux 8.2 Update Services for SAP Solutions

Via RHSA-2024:2041 https://access.redhat.com/errata/RHSA-2024:2041

Comment 12 errata-xmlrpc 2024-04-24 15:39:48 UTC
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 8.6 Extended Update Support

Via RHSA-2024:2039 https://access.redhat.com/errata/RHSA-2024:2039

Comment 13 errata-xmlrpc 2024-04-24 15:42:02 UTC
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 8.4 Advanced Mission Critical Update Support
  Red Hat Enterprise Linux 8.4 Telecommunications Update Service
  Red Hat Enterprise Linux 8.4 Update Services for SAP Solutions

Via RHSA-2024:2042 https://access.redhat.com/errata/RHSA-2024:2042

Comment 14 errata-xmlrpc 2024-04-24 15:44:42 UTC
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 9.2 Extended Update Support

Via RHSA-2024:2040 https://access.redhat.com/errata/RHSA-2024:2040

Comment 15 errata-xmlrpc 2024-04-24 15:45:16 UTC
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 8.8 Extended Update Support

Via RHSA-2024:2038 https://access.redhat.com/errata/RHSA-2024:2038

Comment 16 errata-xmlrpc 2024-04-29 02:46:57 UTC
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 7

Via RHSA-2024:2080 https://access.redhat.com/errata/RHSA-2024:2080

Comment 17 errata-xmlrpc 2024-04-30 16:41:28 UTC
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 9

Via RHSA-2024:2616 https://access.redhat.com/errata/RHSA-2024:2616

Comment 19 errata-xmlrpc 2024-05-22 11:39:33 UTC
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 8

Via RHSA-2024:3258 https://access.redhat.com/errata/RHSA-2024:3258

Comment 20 errata-xmlrpc 2024-05-22 11:40:19 UTC
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 8

Via RHSA-2024:3261 https://access.redhat.com/errata/RHSA-2024:3261

Comment 21 errata-xmlrpc 2024-05-23 15:28:35 UTC
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 8

Via RHSA-2024:3343 https://access.redhat.com/errata/RHSA-2024:3343